// we have to define jquery functions for the background page since
// we do not have access to the library
$ = {
    browser: {
        chrome: false,
        webkit: false,
        mozilla: true
    },
    isFunction: function(target) {
        return (typeof target) === "function";
    },
    isArray: function(target) {
        return (typeof target) === "array";
    },
    isPlainObject: function(target) {
        return (typeof target) === "object";
    },
    extend: function() {
        // taken straight from the jquery source
        var options, name, src, copy, copyIsArray, clone,
            target = arguments[0] || {},
            i = 1,
            length = arguments.length,
            deep = false;

        // Handle a deep copy situation
        if ( typeof target === "boolean" ) {
            deep = target;
            target = arguments[1] || {};
            // skip the boolean and the target
            i = 2;
        }

        // Handle case when target is a string or something (possible in deep copy)
        if ( typeof target !== "object" && !$.isFunction(target) ) {
            target = {};
        }

        // extend jQuery itself if only one argument is passed
        if ( length === i ) {
            target = this;
            --i;
        }

        for ( ; i < length; i++ ) {
            // Only deal with non-null/undefined values
            if ( (options = arguments[ i ]) != null ) {
                // Extend the base object
                for ( name in options ) {
                    src = target[ name ];
                    copy = options[ name ];

                    // Prevent never-ending loop
                    if ( target === copy ) {
                        continue;
                    }

                    // Recurse if we're merging plain objects or arrays
                    if ( deep && copy && ( $.isPlainObject(copy) || (copyIsArray = $.isArray(copy)) ) ) {
                        if ( copyIsArray ) {
                            copyIsArray = false;
                            clone = src && $.isArray(src) ? src : [];

                        } else {
                            clone = src && $.isPlainObject(src) ? src : {};
                        }

                        // Never move original objects, clone them
                        target[ name ] = $.extend( deep, clone, copy );

                    // Don't bring in undefined values
                    } else if ( copy !== undefined ) {
                        target[ name ] = copy;
                    }
                }
            }
        }

        // Return the modified object
        return target;
    }
};
function Log(level,logger,prefix){var _currentLevel=Log.WARN;var _logger=Log.writeLogger;var _prefix=false;this.setPrefix=function(pre){if(pre!='undefined'){_prefix=pre;}
else{_prefix=false;}}
this.setLogger=function(logger){if(logger!='undefined'){_logger=logger;}}
this.setLevel=function(level){if(level!='undefined'&&typeof level=='number'){_currentLevel=level;}else if(level!='undefined'){if(level=='debug'){_currentLevel=Log.DEBUG;}
else if(level=='info'){_currentLevel=Log.INFO;}
else if(level=='error'){_currentLevel=Log.ERROR;}
else if(level=='fatal'){_currentLevel=Log.FATAL;}
else if(level=='warn'){_currentLevel=Log.WARN;}
else{_currentLevel=Log.NONE;}}}
this.getPrefix=function(){return _prefix;}
this.getLogger=function(){return _logger;}
this.getLevel=function(){return _currentLevel;}
if(level!='undefined'){this.setLevel(level);}
if(logger!='undefined'){this.setLogger(logger);}
if(prefix!='undefined'){this.setPrefix(prefix);}}
Log.prototype.debug=function(s){if(this.getLevel()<=Log.DEBUG){this._log(s,"DEBUG",this);}}
Log.prototype.info=function(s){if(this.getLevel()<=Log.INFO){this._log(s,"INFO",this);}}
Log.prototype.warn=function(s){if(this.getLevel()<=Log.WARN){this._log(s,"WARN",this);}}
Log.prototype.error=function(s){if(this.getLevel()<=Log.ERROR){this._log(s,"ERROR",this);}}
Log.prototype.fatal=function(s){if(this.getLevel()<=Log.FATAL){this._log(s,"FATAL",this);}}
Log.prototype._log=function(msg,level,obj){if(this.getPrefix()){this.getLogger()(this.getPrefix()+" - "+msg,level,obj);}else{this.getLogger()(msg,level,obj);}}
Log.DEBUG=1;Log.INFO=2;Log.WARN=3;Log.ERROR=4;Log.FATAL=5;Log.NONE=6;Log.alertLogger=function(msg,level){alert(level+" - "+msg);}
Log.writeLogger=function(msg,level){document.writeln(level+"&nbsp;-&nbsp;"+msg+"<br/>");}
Log.consoleLogger=function(msg,level,obj){if(window.console){window.console.log(level+" - "+msg);}else{Log.popupLogger(msg,level,obj);}}
Log.popupLogger=function(msg,level,obj){if(obj.popupBlocker){return;}
if(!obj._window||!obj._window.document){obj._window=window.open("",'logger_popup_window','width=420,height=320,scrollbars=1,status=0,toolbars=0,resizable=1');if(!obj._window){obj.popupBlocker=true;alert("You have a popup window manager blocking the log4js log popup display.\n\nThis must be disabled to properly see logged events.");return;}
if(!obj._window.document.getElementById('loggerTable')){obj._window.document.writeln("<table width='100%' id='loggerTable'><tr><th align='left'>Time</th><th width='100%' colspan='2' align='left'>Message</th></tr></table>");obj._window.document.close();}}
var tbl=obj._window.document.getElementById("loggerTable");var row=tbl.insertRow(-1);var cell_1=row.insertCell(-1);var cell_2=row.insertCell(-1);var cell_3=row.insertCell(-1);var d=new Date();var h=d.getHours();if(h<10){h="0"+h;}
var m=d.getMinutes();if(m<10){m="0"+m;}
var s=d.getSeconds();if(s<10){s="0"+s;}
var date=(d.getMonth()+1)+"/"+d.getDate()+"/"+d.getFullYear()+"&nbsp;-&nbsp;"+h+":"+m+":"+s;cell_1.style.fontSize="8pt";cell_1.style.fontWeight="bold";cell_1.style.paddingRight="6px";cell_2.style.fontSize="8pt";cell_3.style.fontSize="8pt";cell_3.style.whiteSpace="nowrap";cell_3.style.width="100%";if(tbl.rows.length%2==0){cell_1.style.backgroundColor="#eeeeee";cell_2.style.backgroundColor="#eeeeee";cell_3.style.backgroundColor="#eeeeee";}
cell_1.innerHTML=date
cell_2.innerHTML=level;cell_3.innerHTML=msg;}
Log.dumpObject=function(obj,indent){if(!indent){indent="";}
if(indent.length>20){return;}
var s="{\n";for(var p in obj){s+=indent+p+":";var type=typeof(obj[p]);type=type.toLowerCase();if(type=='object'){s+=Log.dumpObject(obj[p],indent+"----");}else{s+=obj[p];}
s+="\n";}
s+=indent+"}";return s;};

function logObject(obj) {
    console.log(Log.dumpObject(obj));
}

function logNow(label) {
    console.log(label + " : " + (new Date()).getTime());
}var Yesware = Yesware || {};

(function() {
    this.Helpers = function() {

        function isUserObject(storageKey) {
            var tokens = storageKey.split(".");
            return (tokens[tokens.length - 1] === "user");
        }

        /**
         * Applies a modification to the provided Content-Security-Policy header value
         * to allow the extension to inject and load Yesware iframes within Gmail.
         * See: https://mixmax.com/blog/gmail-just-broke-every-chrome-extension
         */
        function modifyCSPHeader(originalCSPHeader) {

            // Add additional hosts here in order to iframe other Yesware app domains
            var iframeHosts = [
                "https://*.yesware.com",
                "https://*.yetihut.com",
                "https://yesware-ka-ching.herokuapp.com",
                "https://yesware-ka-ching-dev.herokuapp.com",
                "https://yesware-account-completion.herokuapp.com",
                "https://yesware-account-completion-dev.herokuapp.com",
                "https://yesware-peacockosaurus-dev.herokuapp.com",
                "https://yesware-simon-says.herokuapp.com",
                "https://yesware-simon-says-dev.herokuapp.com"
            ].join(" ");

            return originalCSPHeader.replace('frame-src', 'frame-src ' + iframeHosts);
        }

        return {
            isUserObject: isUserObject,
            modifyCSPHeader: modifyCSPHeader
        }
    };


}).apply(Yesware);

var Yesware = Yesware || {};

(function() {
    this.Config = function() {
        var BASE = "https://app.yesware.com";
        var IDENTITY_URL = "https://id.yesware.com";
        var CAMPAIGNS_URL = "https://mailmerge.yesware.com";
        var SALESFORCE_URL = "https://avalanche.yesware.com";
        var VERSION = "production", DEVELOPMENT = false;
        var PRESENTATION_URL = "https://presentations.yesware.com";
        var REPORTING_URL = "https://yesware-cronkite.herokuapp.com";
        var ACCOUNT_COMPLETION_URL = "https://yesware-account-completion.herokuapp.com";

        // shared regex
        /////////////////////
        function getTrackingPixelRegex() {
            return new RegExp("#.+\/[0-9a-fA-F]{40}\/[0-9a-fA-F]{32}\/spacer\.gif");
        }

        // users
        /////////////////////
        function getShowUser(params) {
            return authUrl("/api/v1/users", params);
        }

        function postCreateUser() {
            return BASE + "/api/v1/users";
        }

        function putUpdateUser(params) {
            return authUrl("/api/v1/users", params);
        }

        function getLookupUser(params) {
            return BASE + "/api/v1/users/lookup_current?email=" + params.email;
        }

        function signoutUser(params) {
            return BASE + "/users/sign_out";
        }

        // user preferences
        /////////////////////
        function getShowUserPreferences(params) {
            return authUrl("/api/v1/users/user_preferences", params);
        }

        function putUpdateUserPreferences(params) {
            return authUrl("/api/v1/users/user_preferences", params);
        }

        function postImportUserPreferences(params) {
            return authUrl("/api/v1/users/user_preferences/import", params);
        }

        // teams
        /////////////////////
        function getShowTeam(params) {
            return authUrl("/api/v1/teams/" + params.teamId, params);
        }

        // templates
        /////////////////////
        function getTemplate(params) {
            return authUrl("/api/v1/template_library/templates/" + params.templateId, params);
        }

        // template library
        /////////////////////
        function getTemplateLibraryCategories(params) {
            return authUrl("/api/v1/template_library", params);
        }

        function searchTemplateLibrary(params) {
            return authUrl("/api/v1/template_library/search?category=" + params.category, params);
        }

        function getTopTeamTemplates(params) {
            return reportingAuthUrl("/api/v1/reports/team_templates/" + params.teamId, params);
        }

        // tracking
        /////////////////////
        function getMessages(params) {
            return authUrl("/api/v1/messages", params);
        }

        function postCreateMessage(params) {
            return authUrl("/api/v1/messages", params);
        }

        function putUpdateMessage(params) {
            return authUrl("/api/v1/messages/" + params.id, params);
        }

        // reminders
        /////////////////////
        function postCreateReminder(params) {
            return authUrl("/api/v1/reminders", params);
        }

        function putUpdateReminder(params) {
            return authUrl("/api/v1/reminders/" + params.id, params);
        }

        function deleteReminder(params) {
            return authUrl("/api/v1/reminders/" + params.id, params);
        }

        // scheduled message
        /////////////////////
        function getScheduledMessages(params) {
            return BASE + "/api/v1/scheduled_messages?auth_token=" + params.authToken +
                "&per_page=" + params.perPage + "&page=" + params.page + "&status=" + params.status;
        }

        function createScheduledMessage(params) {
            return authUrl("/api/v1/scheduled_messages", params);
        }

        function updateScheduledMessage(params) {
            return authUrl("/api/v1/scheduled_messages/" + params.id, params);
        }

        function deleteScheduledMessage(params) {
            return authUrl("/api/v1/scheduled_messages/" + params.id, params);
        }

        function getScheduledMessage(params) {
            return authUrl("/api/v1/scheduled_messages/" + params.id, params);
        }

        // usages
        /////////////////////
        function postBatchUsage(params) {
            return authUrl("/api/v1/usages/batch", params);
        }

        function postCreateUsage() {
            return BASE + "/api/v1/usages";
        }

        // events
        /////////////////////
        function getEvents(params) {
            return BASE + "/api/v1/message_events_summary/grouped?auth_token=" + params.authToken;
        }

        function getThreadEvents(params) {
            return authUrl("/api/v1/thread_events", params);
        }

        // extension error logs
        /////////////////////
        function postCreateErrorLog() {
            return BASE + "/api/v1/extension_error_logs";
        }

        // proxy
        /////////////////////
        function getProxy(params) {
            return authUrl("/api/v1/proxy?dest_url=" + encodeURIComponent(params.url), params);
        }

        // Services
        /////////////////////
        function getCrmMetadata(params) {
            return authUrl("/api/v1/crm/metadata/" + params.service, params);
        }

        // Message Thread
        /////////////////////
        function getCrmMessageThread(params) {
            return authUrl("/api/v1/crm/message_thread/" + params.threadId + ".json", params);
        }

        // calendar event map
        /////////////////////
        function getCalendarEventMap(params) {
            return authUrl("/api/v1/crm/salesforce/gcal_event_maps/" + params.eventMapId, params);
        }

        function postCalendarEventMap(params) {
            return authUrl("/api/v1/crm/salesforce/gcal_event_maps", params);
        }

        function putCalendarEventMap(params) {
            return authUrl("/api/v1/crm/salesforce/gcal_event_maps/" + params.eventMapId, params);
        }

        // feature tours
        /////////////////////
        function getUserFeatureTour(params) {
            return authUrl("/api/v1/feature_tours/feature_tours", params);
        }

        function updateUserFeatureTour(params) {
            return authUrl("/api/v1/feature_tours/feature_tours/" + params.id, params);
        }

        function getFeatureTourContent(params) {
            return authUrl("/api/v1/partials/feature_tours/" + params.featureName, params);
        }

        // campaigns
        /////////////////////
        function postCampaignsApply(params) {
            return campaignsAuthUrl("/drip_campaigns/apply", params);
        }

        // salesforce
        /////////////////////
        function getSalesforcePhones(params) {
            return salesforceAuthUrl("/phones", params);
        }

        // Backbone:
        // The generic methods proxy requests for Backbone.
        ///////////////////////////////////////////////////////////
        function backboneCampaignsRequestUrl(params) {
            return _this.campaignsAuthUrl(params.url, params);
        }

        function backboneBackendRequestUrl(params) {
            return _this.authUrl(params.url, params);
        }

        function backbonePresentationsRequestUrl(params) {
            return _this.presentationsAuthUrl(params.url, params);
        }

        function backboneAccountCompletionRequestUrl(params) {
            return _this.accountCompletionAuthUrl(params.url, params);
        }

        // availability
        /////////////////////
        function getAvailability(params) {
            return _this.authUrl("/api/v1/availability", params);
        }

        // upload parameters for file attachment
        /////////////////////
        function createUploadParameters(params) {
            return identityAuthUrl("/upload_parameters", params);
        }

        // presentations
        /////////////////////
        function postCreatePresentations(params) {
            return _this.presentationsAuthUrl("/presentations", params);
        }

        // account completion
        /////////////////////
        function postCreateAccountCompletionStepForUser(params) {
            return _this.accountCompletionAuthUrl("/completion_statuses", params);
        }

        // private
        /////////////////////
        function generateAuthUrl(baseUrl, resource, params) {
            if (resource.indexOf("?") === -1) {
                return baseUrl + resource + "?auth_token=" + params.authToken;
            } else {
                // append to resource if authToken is not the first query param
                return baseUrl + resource + "&auth_token=" + params.authToken;
            }
        }

        function authUrl(resource, params) {
            return _this.generateAuthUrl(BASE, resource, params);
        }

        function identityAuthUrl(resource, params) {
            return _this.generateAuthUrl(IDENTITY_URL, resource, params);
        }

        function campaignsAuthUrl(resource, params) {
            return _this.generateAuthUrl(CAMPAIGNS_URL, resource, params);
        }

        function presentationsAuthUrl(resource, params) {
            return _this.generateAuthUrl(PRESENTATION_URL, resource, params);
        }

        function reportingAuthUrl(resource, params) {
            return _this.generateAuthUrl(REPORTING_URL, resource, params);
        }

        function accountCompletionAuthUrl(resource, params) {
            if (params.stepName) {
                return _this.generateAuthUrl(ACCOUNT_COMPLETION_URL, resource, params) + "&step_name=" + params.stepName;
            } else {
                return _this.generateAuthUrl(ACCOUNT_COMPLETION_URL, resource, params);
            }
        }

        function salesforceAuthUrl(resource, params) {
            return _this.generateAuthUrl(SALESFORCE_URL, resource, params);
        }

        var _this = {
            regex: {
                trackingPixel: getTrackingPixelRegex
            },
            api: {
                users: {
                    show: getShowUser,
                    create: postCreateUser,
                    update: putUpdateUser,
                    lookup: getLookupUser,
                    signout: signoutUser
                },
                userPreferences: {
                    show: getShowUserPreferences,
                    update: putUpdateUserPreferences,
                    import: postImportUserPreferences
                },
                teams: {
                    show: getShowTeam
                },
                templates: {
                    show: getTemplate
                },
                templateLibrary: {
                    index: getTemplateLibraryCategories,
                    search: searchTemplateLibrary,
                    topTemplates: getTopTeamTemplates
                },
                messages: {
                    index: getMessages,
                    create: postCreateMessage,
                    update: putUpdateMessage
                },
                reminders: {
                    create: postCreateReminder,
                    update: putUpdateReminder,
                    delete: deleteReminder
                },
                scheduledMessage: {
                    index: getScheduledMessages,
                    create: createScheduledMessage,
                    update: updateScheduledMessage,
                    delete: deleteScheduledMessage,
                    get: getScheduledMessage
                },
                usages: {
                    batch: postBatchUsage,
                    create: postCreateUsage
                },
                events: {
                    grouped: getEvents,
                    thread: getThreadEvents
                },
                extensionErrorLog: {
                    create: postCreateErrorLog
                },
                proxy: {
                    get: getProxy
                },
                crmMetadata: {
                    get: getCrmMetadata
                },
                crmMessageThread: {
                    get: getCrmMessageThread
                },
                calendarEventMap: {
                    get: getCalendarEventMap,
                    create: postCalendarEventMap,
                    update: putCalendarEventMap
                },
                featureTours: {
                    get: getUserFeatureTour,
                    update: updateUserFeatureTour,
                    getContent: getFeatureTourContent
                },
                campaigns: {
                    apply: postCampaignsApply
                },
                salesforce: {
                    getPhones: getSalesforcePhones
                },
                backbone: {
                    campaigns: backboneCampaignsRequestUrl,
                    backend: backboneBackendRequestUrl,
                    presentations: backbonePresentationsRequestUrl,
                    accountCompletion: backboneAccountCompletionRequestUrl
                },
                availability: {
                    get: getAvailability
                },
                uploadParameters: {
                    create: createUploadParameters
                },
                presentations: {
                    create: postCreatePresentations
                },
                accountCompletion: {
                    create: postCreateAccountCompletionStepForUser
                }
            },

            // open for jasmine
            generateAuthUrl: generateAuthUrl,
            authUrl: authUrl,
            identityAuthUrl: identityAuthUrl,
            campaignsAuthUrl: campaignsAuthUrl,
            presentationsAuthUrl: presentationsAuthUrl,
            reportingAuthUrl: reportingAuthUrl,
            accountCompletionAuthUrl: accountCompletionAuthUrl,
            salesforceAuthUrl: salesforceAuthUrl
        };

        return _this;
    };
}).apply(Yesware);
// chrome has jquery defined, firefox does not
var Yesware = Yesware || {};
var Request, notifications, simpleStorage, ffSelf;

if ($.browser.mozilla) {
    Request = require("request").Request;
    notifications = require("notifications");
    simpleStorage = require("simple-storage");
    ffSelf = require("self");
} else if (!$.browser.chrome) {
    var VERSION = "devlocal";
    var VERSION = "production", DEVELOPMENT = false;
    if (VERSION === "test") {
        // If the browser is not Firefox or Chrome, pretend to be Chrome
        // in the test environment. This is for jasmine:ci.
        $.browser.chrome = true;
    }
}

/**********************************************************
 * STOP! THIS FILE IS DEPRECATED!                         *
 * DO NOT ADD NEW CODE HERE OR USE THESE FUNCTIONS UNLESS *
 * YOU HAVE A VERY GOOD REASON.                           *
 * LOOK AT yesware.request.js INSTEAD.                    *
 **********************************************************/

(function () {
    this.Api = function (buildVersion, packageVersion) {
        var OAUTH_LANDING_REGEX = "(.+):\/\/app.yesware.com\/oauth_success";

        // fields
        /////////////////////
        var yesConfig = Yesware.Config();
        var apiConfig = yesConfig.api;

        // api access
        /////////////////////
        function sendRequest(globalOptions, chromeOptions, firefoxOptions) {
            if ($.browser.webkit) {
                // copy
                var chromeRequest = $.extend(true, globalOptions, chromeOptions);
                delete chromeRequest["sender"];

                sendChromeRequest(chromeRequest, chromeOptions.sender);
            } else {
                var firefoxRequest = $.extend(globalOptions, firefoxOptions);

                firefoxRequest.onComplete = function (response) {
                    // Note: the status and statusText from the response are NOT
                    // passed to the callback.
                    sendRequestCallback(firefoxOptions.action, firefoxOptions.requestId, response.json, firefoxOptions.worker);
                };

                delete firefoxRequest["action"];
                delete firefoxRequest["worker"];

                // firefox uses lowercase request type key
                sendFirefoxRequest(firefoxRequest, firefoxRequest.type.toLowerCase());
            }
        }

        // chrome specific
        /////////////////////
        function sendChromeRequest(options, sender) {
            // inspired by: http://zeroedandnoughted.com/defensive-ajax-and-ajax-retries-in-jquery/
            var settings = {
                data: {
                    build_version: buildVersion,
                    package_version: packageVersion
                },
                success: function () {
                },
                cache: true,
                tryCount: 0,
                retryLimit: 3,
                error: defaultErrorHandler
            };

            // deep copy
            settings = $.extend(true, settings, options);

            settings.success = function (response) {
                handleExtensionError(response, options.success, sender);
            };

            $.ajax(settings);
        }

        function defaultErrorHandler(xhr, textStatus, errorThrown) {
            // "this" refers to the AJAX function, not to the module
            var self = this;
            self.tryCount++;

            if (self.tryCount > 0) {
                // on first retry, append timestamp to end of url to bust chrome cache
                var timestamp = (new Date()).getTime();

                if (self.url.indexOf("?") === -1) {
                    self.url += ("?" + timestamp);
                } else {
                    self.url += ("&" + timestamp);
                }
            }

            if (self.tryCount <= self.retryLimit) {
                // 5s after first failure, 25s after 2nd, 125s after 3rd
                var tryNextAfter = 1000 * (Math.pow(5, self.tryCount));

                setTimeout(function () {
                    $.ajax(self);
                }, tryNextAfter);
            }
        }

        function handleExtensionError(response, successCallback, sender) {
            try {
                if (response.system_messages != null && response.system_messages.length > 0) {
                    // lets just check the first one
                    var message = response.system_messages[0];

                    // deliberately not checking for 102
                    if (message.code >= 100 && message.code <= 101) {
                        // could be a disconnected port object
                        sendRequestToTab(sender.tab.id, "message.show", message);
                    }

                    successCallback(response);
                } else {
                    successCallback(response);
                }
            } catch (e) {
                console.log(e);
            }
        }

        // firefox specific
        /////////////////////
        function sendFirefoxRequest(options, type) {
            if (options.content === undefined)
                options.content = {};

            options.content.build_version = buildVersion;
            options.content.package_version = packageVersion;

            if (type === 'get') {
                Request(options).get();
            } else if (type === 'post') {
                Request(options).post();
            } else if (type === 'put') {
                Request(optionsForFirefox(options, "PUT")).post();
            } else if (type === 'delete') {
                Request(optionsForFirefox(options, "DELETE")).post();
            }
        }

        function optionsForFirefox(options, verb) {
            // hack around the fact that FF sdk doesn't support PUT
            if (typeof options.content === 'undefined')
                options.content = {};

            options.content["_method"] = verb;
            return options;
        }

        function sendRequestCallback(actionName, requestId, data, worker) {
            // handle extension messages
            if (data != null &&
                data.system_messages !== undefined &&
                data.system_messages.length > 0) {

                // just pick the first one
                var message = data.system_messages[0];
            }

            worker.postMessage({
                actionName: actionName,
                requestId: requestId,
                data: data
            });
        }

        // users
        /////////////////////
        function getShowUser(request, callback, sender, worker) {
            // this method is a special case
            if ($.browser.chrome) {
                sendChromeRequest({
                    type: "GET",
                    url: apiConfig.users.show(request.params),
                    success: callback
                }, sender);
            } else {
                // firefox
                var actionName = "users.show";

                // needed for oauth, 2 code paths can go into hit this function
                // 1: standard fetch user, 2: on auth save
                if (request.altActionName != null)
                    actionName = request.altActionName;

                sendFirefoxRequest({
                    url: apiConfig.users.show(request.params),
                    onComplete: function (response) {
                        var user = response.json;

                        // go one step deeper to take out system_messages
                        if (request.altActionName != null && request.altActionName === "oauth.save")
                            user = response.json.user;

                        sendRequestCallback(actionName, request.requestId, user, worker);
                    }
                }, "get");
            }
        }

        function postCreateUser(request, callback, sender, worker) {
            sendRequest({
                type: "POST",
                url: apiConfig.users.create()
            }, {
                success: callback,
                error: callback,
                data: request.data,
                sender: sender
            }, {
                content: request.data,
                action: request.action,
                requestId: request.requestId,
                worker: worker
            })
        }

        function putUpdateUser(request, callback, sender, worker) {
            sendRequest({
                type: "PUT",
                url: apiConfig.users.update(request.params)
            }, {
                success: callback,
                data: request.data,
                sender: sender
            }, {
                content: request.data,
                action: request.action,
                requestId: request.requestId,
                worker: worker
            })
        }

        function getLookupUser(request, callback, sender, worker) {
            sendRequest({
                type: "GET",
                url: apiConfig.users.lookup(request.params)
            }, {
                success: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function signoutUser(request, callback, sender, worker) {
            sendRequest({
                type: "GET",
                url: apiConfig.users.signout(request.params)
            }, {
                success: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        // userPreferences
        /////////////////////
        function getShowUserPreferences(request, callback, sender, worker) {
            sendRequest({
                type: "GET",
                url: apiConfig.userPreferences.show(request.params)
            }, {
                success: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function putUpdateUserPreferences(request, callback, sender, worker) {
            sendRequest({
                type: "PUT",
                url: apiConfig.userPreferences.update(request.params)
            }, {
                success: callback,
                error: callback,
                data: request.data,
                sender: sender
            }, {
                content: request.data,
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function postImportUserPreferences(request, callback, sender, worker) {
            sendRequest({
                type: "POST",
                url: apiConfig.userPreferences.import(request.params)
            }, {
                success: callback,
                error: callback,
                data: request.data,
                sender: sender
            }, {
                content: request.data,
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        // teams
        /////////////////////
        function getShowTeam(request, callback, sender, worker) {
            sendRequest({
                type: "GET",
                url: apiConfig.teams.show(request.params)
            }, {
                success: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        // template library
        /////////////////////
        function getTemplate(request, callback, sender, worker) {
            sendRequest({
                type: "GET",
                url: apiConfig.templates.show(request.params)
            }, {
                success: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function getTemplateLibraryCategories(request, callback, sender, worker) {
            sendRequest({
                type: "GET",
                url: apiConfig.templateLibrary.index(request.params)
            }, {
                success: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function searchTemplateLibrary(request, callback, sender, worker) {
            sendRequest({
                type: "GET",
                url: apiConfig.templateLibrary.search(request.params)
            }, {
                success: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function getTopTemplates(request, callback, sender, worker) {
            sendRequest({
                type: "GET",
                url: apiConfig.templateLibrary.topTemplates(request.params)
            }, {
                data: request.data,
                success: callback,
                sender: sender
            }, {
                content: request.data,
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        // tracking
        /////////////////////
        function getMessages(request, callback, sender, worker) {
            sendRequest({
                type: "GET",
                url: apiConfig.messages.index(request.params)
            }, {
                success: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function postCreateMessage(request, callback, sender, worker) {
            sendRequest({
                type: "POST",
                url: apiConfig.messages.create(request.params)
            }, {
                data: request.data,
                success: callback,
                sender: sender
            }, {
                content: request.data,
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function putUpdateMessage(request, callback, sender, worker) {
            sendRequest({
                type: "PUT",
                url: apiConfig.messages.update(request.params)
            }, {
                data: request.data,
                success: callback,
                sender: sender
            }, {
                content: request.data,
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        // scheduled messages
        /////////////////////
        function indexScheduledMessages(request, callback, sender, worker) {
            sendRequest({
                type: "GET",
                url: apiConfig.scheduledMessage.index(request.params)
            }, {
                success: callback,
                sender: sender
            }, {
                content: request.data,
                action: request.action,
                requestId: request.requestId,
                worker: worker
            })
        }

        function postCreateScheduledMessage(request, callback, sender, worker) {
            sendRequest({
                type: "POST",
                url: apiConfig.scheduledMessage.create(request.params)
            }, {
                data: request.data,
                success: callback,
                sender: sender
            }, {
                content: request.data,
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function putUpdateScheduledMessage(request, callback, sender, worker) {
            sendRequest({
                type: "PUT",
                url: apiConfig.scheduledMessage.update(request.params)
            }, {
                data: request.data,
                success: callback,
                sender: sender
            }, {
                content: request.data,
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function deleteScheduledMessage(request, callback, sender, worker) {
            sendRequest({
                type: "DELETE",
                url: apiConfig.scheduledMessage.delete(request.params)
            }, {
                success: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function getScheduledMessage(request, callback, sender, worker) {
            sendRequest({
                type: "GET",
                url: apiConfig.scheduledMessage.get(request.params)
            }, {
                success: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        // reminders
        /////////////////////
        function postCreateReminder(request, callback, sender, worker) {
            sendRequest({
                type: "POST",
                url: apiConfig.reminders.create(request.params)
            }, {
                data: request.data,
                success: callback,
                sender: sender
            }, {
                content: request.data,
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function putUpdateReminder(request, callback, sender, worker) {
            sendRequest({
                type: "PUT",
                url: apiConfig.reminders.update(request.params)
            }, {
                data: request.data,
                success: callback,
                sender: sender
            }, {
                content: request.data,
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function deleteReminder(request, callback, sender, worker) {
            sendRequest({
                type: "DELETE",
                url: apiConfig.reminders.delete(request.params)
            }, {
                success: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        // usages
        /////////////////////
        function postBatchUsage(request, callback, sender, worker) {
            sendRequest({
                type: "POST",
                url: apiConfig.usages.batch(request.params)
            }, {
                data: request.data,
                success: callback,
                sender: sender
            }, {
                content: request.data,
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function postCreateUsage(request, callback, sender, worker) {
            sendRequest({
                type: "POST",
                url: apiConfig.usages.create()
            }, {
                data: request.data,
                success: callback,
                sender: sender
            }, {
                content: request.data,
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        // events
        /////////////////////
        function getEvents(request, callback, sender, worker) {
            sendRequest({
                type: "GET",
                url: apiConfig.events.grouped(request.params)
            }, {
                success: callback,
                error: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function getThreadEvents(request, callback, sender, worker) {
            _this.sendRequest({
                type: "GET",
                url: apiConfig.events.thread(request.params)
            }, {
                success: callback,
                error: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        // windows (chrome-specific)
        /////////////////////
        function createWindow(data, sender) {
            var width = 500,
                height = 400;

            if (data.width)
                width = data.width;

            if (data.height)
                height = data.height;

            chrome.windows.create({
                url: data.url,
                width: width,
                height: height,
                type: "popup"
            });
        }

        // navigate to (chrome-specific)
        /////////////////////
        function tabNavigateTo(data, sender) {
            chrome.tabs.update(sender.tab.id, {
                url: data.url
            });
        }

        function tabChangeHashTo(data, sender) {
            chrome.tabs.executeScript(sender.tab.id, {
                code: 'window.location.hash="' + data.hash + '";',
                allFrames: false
            });
        }

        function tabGetUrl(callback, sender) {
            callback(sender.tab.url);
        }

        // localStorage
        /////////////////////
        function saveLocalStorage(data) {
            if ($.browser.chrome) {
                localStorage[data.key] = data.value;
            } else {
                simpleStorage.storage[data.key] = String(data.value);
            }
        }

        function loadLocalStorage(request, callback, worker) {
            var key = request.data.key;

            if ($.browser.chrome) {
                callback(localStorage[key]);
            } else {
                sendRequestCallback(request.action, request.requestId, simpleStorage.storage[key], worker);
            }
        }

        function deleteLocalStorage(data) {
            if ($.browser.chrome) {
                delete localStorage[data.key];
            } else {
                delete simpleStorage.storage[data.key];
            }
        }

        // background
        /////////////////////
        function getBackgroundUsers(request, callback, worker) {
            var users = [],
                re = /^extension\.yesware\.(.+)\.user$/;

            if ($.browser.chrome) {
                for (var key in localStorage) {
                    if (localStorage.hasOwnProperty(key) && re.test(key)) {
                        users.push(
                            JSON.parse(localStorage[key])
                        );
                    }
                }

                callback(users);
            } else {
                var storage = simpleStorage.storage;

                for (var key in storage) {
                    if (storage.hasOwnProperty(key) && re.test(key)) {
                        users.push(
                            JSON.parse(storage[key])
                        );
                    }
                }

                sendRequestCallback(
                    request.action,
                    request.requestId,
                    users,
                    worker
                );
            }
        }

        // extension error logs
        /////////////////////
        function postCreateErrorLog(request, callback, sender, worker) {
            // more detail we can add, the better
            request.data.package_version = packageVersion;

            sendRequest({
                type: "POST",
                url: apiConfig.extensionErrorLog.create()
            }, {
                data: request.data,
                success: callback,
                sender: sender
            }, {
                content: request.data,
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        // Salesforce
        ///////////////////
        function salesforceGetRequest(request, callback, sender, worker) {
            // request properties:
            //   url
            //   headers

            sendRequest({
                type: "GET",
                url: request.url,
                cache: false,
                dataType: "json",
                headers: request.headers
            }, {
                error: callback,
                success: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function salesforcePostRequest(request, callback, sender, worker) {
            // request properties:
            //   url

            sendRequest({
                type: "POST",
                url: request.url,
                dataType: "json",
                headers: request.headers
            }, {
                error: callback,
                success: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function getSalesforcePhones(request, callback, sender, worker) {
            _this.sendRequest({
                type: "GET",
                url: apiConfig.salesforce.getPhones(request.params)
            }, {
                success: callback,
                error: callback,
                data: request.data,
                sender: sender
            }, {
                content: request.data,
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        // Services
        ///////////////////
        function getCrmMetadata(request, callback, sender, worker) {
            sendRequest({
                type: "GET",
                url: apiConfig.crmMetadata.get(request.params)
            }, {
                success: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        // Message Thread
        /////////////////////
        function getCrmMessageThread(request, callback, sender, worker) {
            sendRequest({
                type: "GET",
                url: apiConfig.crmMessageThread.get(request.params)
            }, {
                success: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        // calendar event map
        /////////////////////
        function getCalendarEventMap(request, callback, sender, worker) {
            sendRequest({
                type: "GET",
                url: apiConfig.calendarEventMap.get(request.params)
            }, {
                success: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function createCalendarEventMap(request, callback, sender, worker) {
            sendRequest({
                type: "POST",
                url: apiConfig.calendarEventMap.create(request.params)
            }, {
                success: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function updateCalendarEventMap(request, callback, sender, worker) {
            sendRequest({
                type: "PUT",
                url: apiConfig.calendarEventMap.update(request.params)
            }, {
                data: request.data,
                success: callback,
                sender: sender
            }, {
                content: request.data,
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        // feature tours
        /////////////////////
        function getUserFeatureTour(request, callback, sender, worker) {
            sendRequest({
                type: "GET",
                url: apiConfig.featureTours.get(request.params)
            }, {
                success: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function updateUserFeatureTour(request, callback, sender, worker) {
            sendRequest({
                type: "PUT",
                url: apiConfig.featureTours.update(request.params)
            }, {
                data: request.data,
                success: callback,
                sender: sender
            }, {
                content: request.data,
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function getFeatureTourContent(request, callback, sender, worker) {
            sendRequest({
                type: "GET",
                url: apiConfig.featureTours.getContent(request.params)
            }, {
                success: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        //campaigns
        function postCampaignsApply(request, callback, sender, worker) {
            _this.sendRequest({
                type: "POST",
                url: apiConfig.campaigns.apply(request.params)
            }, {
                data: request.data,
                success: callback,
                sender: sender
            }, {
                content: request.data,
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        // Backbone:
        // These methods provide a generic API to proxy Backbone requests
        //////////////////////////////////////////////////////////////////
        function backboneGet(request, callback, sender, worker) {
            _this.sendRequest({
                type: "GET",
                url: backboneServerUrl(request.params)
            }, {
                success: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function backbonePost(request, callback, sender, worker) {
            _this.sendRequest({
                type: "POST",
                url: backboneServerUrl(request.params)
            }, {
                data: request.data,
                success: callback,
                sender: sender
            }, {
                content: request.data,
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function backbonePut(request, callback, sender, worker) {
            _this.sendRequest({
                type: "PUT",
                url: backboneServerUrl(request.params)
            }, {
                data: request.data,
                success: callback,
                sender: sender
            }, {
                content: request.data,
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function backboneDelete(request, callback, sender, worker) {
            _this.sendRequest({
                type: "DELETE",
                url: backboneServerUrl(request.params)
            }, {
                success: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        function backboneServerUrl(params) {
            switch (params.resourceServer.toLowerCase()) {
            case "backend":
                return apiConfig.backbone.backend(params);
            case "campaigns":
                return apiConfig.backbone.campaigns(params);
            case "presentations":
                return apiConfig.backbone.presentations(params);
            case "account_completion":
                return apiConfig.backbone.accountCompletion(params);
            }
        }

        // availability
        /////////////////////
        function getAvailability(request, callback, sender, worker) {
            _this.sendRequest({
                type: "GET",
                url: apiConfig.availability.get(request.params)
            }, {
                success: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        // upload parameters for file attachments
        /////////////////////
        function postCreateUploadParameters(request, callback, sender, worker) {
            sendRequest({
                type: "POST",
                url: apiConfig.uploadParameters.create(request.params)
            }, {
                data: request.data,
                success: callback,
                sender: sender
            }, {
                content: request.data,
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        // presentations
        //////////////////////
        function postCreatePresentation(request, callback, sender, worker) {
            _this.sendRequest({
                type: "POST",
                url: apiConfig.presentations.create(request.params)
            }, {
                data: request.data,
                success: callback,
                sender: sender
            }, {
                content: request.data,
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        // account completion
        //////////////////////
        function postCreateAccountCompletionStepForUser(request, callback, sender, worker) {
            _this.sendRequest({
                type: "POST",
                url: apiConfig.accountCompletion.create(request.params)
            }, {
                success: callback,
                sender: sender
            }, {
                action: request.action,
                requestId: request.requestId,
                worker: worker
            });
        }

        // mixpanel
        /////////////////////
        function trackMixpanelEvent(request) {
            // trackMixpanelEvent is only used in Chrome
            // Ideally crossBrowserTrackMixpanelEvent should be registered as a
            // handler directly, but it's not available in Firefox background
            // and so causes the extension not to load in Firefox
            Yesware.get("Mixpanel").crossBrowserTrackMixpanelEvent(request);
        }

        // oauth
        /////////////////////

        var oauthEmail;

        // chrome
        var gmailTab;

        // firefox
        var gmailOAuthWorker = null, oauthStarted = false;

        function startOAuthProcess(request, sender, worker) {
            oauthEmail = request.data.email;

            if ($.browser.chrome) {
                gmailTab = sender.tab;
            } else {
                gmailOAuthWorker = worker;
                oauthStarted = true;
            }
        }

        function saveBroadcastOAuthToken(request, sender) {
            if ($.browser.chrome) {
                if (gmailTab === undefined || gmailTab === null) {
                    // we have no tab to send back to
                    return;
                }

                if (request.data.email.toLowerCase() !== oauthEmail.toLowerCase()) {
                    // email in UI is different from oauth email, we should warn the user
                    console.log("Email from Gmail: " + request.data.email.toLowerCase());
                    console.log("Email from OAuth: " + oauthEmail.toLowerCase());

                    sendRequestToTab(gmailTab.id, "oauth.error", null);
                    return;
                }

                getShowUser({
                    params: {
                        authToken: request.data.authToken
                    }
                }, function (response) {
                    // user object needs to be persisted in localStorage by content script
                    sendRequestToTab(gmailTab.id, "oauth.save", response.user);

                    // we also close the popup window since it is not needed anymore
                    // must be done this way due to: http://code.google.com/p/chromium/issues/detail?id=40658
                    chromeCloseOAuthPopup();

                    gmailTab = null;
                }, sender, null);
            } else {
                // firefox
                if (!oauthStarted)
                    return;

                if (request.data.email.toLowerCase() !== oauthEmail.toLowerCase()) {
                    console.log("Email from Gmail: " + request.data.email.toLowerCase());
                    console.log("Email from OAuth: " + oauthEmail.toLowerCase());

                    // firefox
                    var actionName = "oauth.error";
                    sendRequestCallback(actionName, request.requestId, null, gmailOAuthWorker);

                    return;
                }

                getShowUser({
                    params: {
                        authToken: request.data.authToken
                    },
                    altActionName: "oauth.save"
                }, null, null, gmailOAuthWorker);

                // don't trigger a 2nd time
                oauthStarted = false;
                gmailOAuthWorker = null;
            }
        }

        function chromeCloseOAuthPopup() {
            var oauthLandingPageRegex = new RegExp(OAUTH_LANDING_REGEX, "i");
            chrome.windows.getAll({
                populate: true
            }, function (windows) {
                $.each(windows, function (i, thisWindow) {
                    var tabs = thisWindow.tabs;

                    // the popup only has one tab
                    if (tabs.length > 1)
                        return true;

                    var searchComplete = false;

                    $.each(thisWindow.tabs, function (i, tab) {
                        // we close the popup if it matches a predefined URL pattern
                        if (tab.url.match(oauthLandingPageRegex) != null) {
                            chrome.windows.remove(thisWindow.id);
                            searchComplete = true;
                        }

                        return false;
                    });

                    if (searchComplete)
                        return false; // we're done
                });
            });
        }

        // google calendar authentication flow
        /////////////////////
        // chrome
        var authFlowTab;

        // firefox
        var authFlowWorker = null, authFlowStarted = false;

        function startGCalAuthFlow(request, sender, worker) {
            if ($.browser.chrome) {
                authFlowTab = sender.tab;
            } else {
                authFlowWorker = worker;
                authFlowStarted = true;
            }
        }

        function completeGCalAuthFlow(request, sender, worker) {
            var actionName = "gcalAuthFlow.complete";

            if ($.browser.chrome) {
                if (authFlowTab == null)
                    return; // we have no tab to send back to

                sendRequestToTab(authFlowTab.id, actionName, {});
                authFlowTab = null;
            } else {
                if (!authFlowStarted)
                    return;

                sendRequestCallback(actionName, request.requestId, null, authFlowWorker);

                authFlowStarted = false;
                authFlowWorker = null;
            }
        }

        // permissions
        /////////////////////
        function checkPermissions(request, callback, sender, worker) {
            var actionName = "permissions.check";

            if ($.browser.chrome) {
                chrome.permissions.contains({
                    origins: ['<all_urls>']
                }, function (grantedPermission) {
                    // The callback argument will be true if the user granted the permissions.
                    callback({permissionsGranted: grantedPermission});
                });
            } else {
                sendRequestCallback(
                    actionName,
                    request.requestId,
                    { permissionsGranted: true },
                    worker
                );
            }
        }

        // events map (chrome-specific)
        /////////////////////
        function passEventsMapMessage(tab, request) {
            // background is just the conduit
            chrome.tabs.sendRequest(tab.id, request);
        }

        // notifications
        /////////////////////
        function showNotification(request, worker) {
            var data = request.data;

            if (data.subject == null)
                data.subject = "(no subject)";

            if ($.browser.chrome) {
                // right now we only show notifications for events
                if (webkitNotifications.createHTMLNotification) {
                    // mac os
                    var subject = encodeURIComponent(data.subject);
                    var person = encodeURIComponent(data.person);
                    var event = encodeURIComponent(data.event);
                    var timeago = encodeURIComponent(data.timeago);

                    var notification = webkitNotifications.createHTMLNotification("notification.html?subject=" + subject + "&event=" + event + "&person=" + person + "&timeago=" + timeago);
                    notification.show();

                    setTimeout(function () {
                        notification.cancel();
                    }, 10000);
                } else {
                    // since Chrome 28, we have a different API to generate notifications for windows
                    chrome.notifications.create("", {
                        type: "basic",
                        title: data.timeago,
                        message: data.person + " " + data.event + " " + data.subject,
                        iconUrl: "images/content/notification_icon.png"
                    }, function() {});
                }
            } else {
                notifications.notify({
                    title: "Yesware Email Event",
                    text: data.person + " " + data.event + ": " + data.subject + " - " + data.timeago,
                    iconURL: self.data.url("notification_icon.png")
                });
            }
        }

        // rich notifications
        /////////////////////
        var CLOSE_AFTER_DEFAULT = 7500;

        function showRichNotification(request, callback, sender, worker) {
            var data = request.data;

            if ($.browser.chrome) {
                var notificationParams = {
                    type: "basic",
                    title: data.title,
                    message: data.message,
                    iconUrl: "images/content/notification_icon.png"
                };

                if (data.buttons)
                    notificationParams.buttons = data.buttons;

                // we are going to assume this is Chrome 28+
                var notificationId = (String)((new Date()).getTime());

                chrome.notifications.create(
                    notificationId,
                    notificationParams,
                    function() {}
                );

                // close the notification after X ms
                var closeAfter = data.closeAfter;

                // 7.5 seconds by default
                if (closeAfter == null)
                    closeAfter = CLOSE_AFTER_DEFAULT;

                setTimeout(function() {
                    chrome.notifications.clear(notificationId, function() {});
                }, closeAfter);

                chrome.notifications.onButtonClicked.addListener(
                    function(thisNotificatonId, buttonIndex) {
                        if (thisNotificatonId === notificationId) {
                            // focus on sender tab
                            chrome.tabs.update(sender.tab.id, { selected: true });

                            if (data.type === "event_notification") {
                                tabChangeHashTo({
                                    hash: data.locationHash
                                }, sender);
                            }

                            // chrome does not allow callbacks to execute more than once
                            // this callback may not work
                            callback(buttonIndex);
                        }
                    }
                );
            } else {
                // firefox
                notifications.notify({
                    title: data.title,
                    text: data.message,
                    iconURL: self.data.url("notification_icon.png")
                });
            }
        }

        // developer
        /////////////////////
        function developerReset() {
            if ($.browser.chrome) {
                localStorage.clear();
                location.reload();
            }
        }

        // message passing (chrome-specific)
        /////////////////////
        function sendRequestToTab(tabId, action, data) {
            chrome.tabs.sendRequest(tabId, {
                action: action,
                data: data
            });
        }

        // jasmine
        /////////////////////
        function getApiConfig() {
            return apiConfig;
        }

        var _this = {
            users: {
                show: getShowUser,
                create: postCreateUser,
                update: putUpdateUser,
                lookup: getLookupUser,
                signout: signoutUser
            },
            userPreferences: {
                show: getShowUserPreferences,
                update: putUpdateUserPreferences,
                import: postImportUserPreferences
            },
            teams: {
                show: getShowTeam
            },
            templateLibrary: {
                show: getTemplate,
                index: getTemplateLibraryCategories,
                search: searchTemplateLibrary,
                topTemplates: getTopTemplates
            },
            messages: {
                index: getMessages,
                create: postCreateMessage,
                update: putUpdateMessage
            },
            scheduledMessage: {
                index: indexScheduledMessages,
                create: postCreateScheduledMessage,
                update: putUpdateScheduledMessage,
                delete: deleteScheduledMessage,
                get: getScheduledMessage
            },
            reminders: {
                create: postCreateReminder,
                update: putUpdateReminder,
                delete: deleteReminder
            },
            usages: {
                batch: postBatchUsage,
                create: postCreateUsage
            },
            events: {
                grouped: getEvents,
                thread: getThreadEvents
            },
            windows: {
                create: createWindow
            },
            tabs: {
                navigateTo: tabNavigateTo,
                changeHashTo: tabChangeHashTo,
                getUrl: tabGetUrl
            },
            extensionErrorLog: {
                create: postCreateErrorLog
            },
            localStorage: {
                save: saveLocalStorage,
                load: loadLocalStorage,
                delete: deleteLocalStorage
            },
            background: {
                getUsers: getBackgroundUsers
            },
            oauth: {
                start: startOAuthProcess,
                save: saveBroadcastOAuthToken
            },
            gcalAuthFlow: {
                start: startGCalAuthFlow,
                complete: completeGCalAuthFlow
            },
            permissions: {
                check: checkPermissions
            },
            eventsMap: {
                passMessage: passEventsMapMessage
            },
            notifications: {
                show: showNotification
            },
            richNotifications: {
                show: showRichNotification
            },
            crmMetadata: {
              show: getCrmMetadata
            },
            crmMessageThread: {
                show: getCrmMessageThread
            },
            salesforce: {
                get: salesforceGetRequest,
                post: salesforcePostRequest,
                getPhones: getSalesforcePhones
            },
            calendarEventMap: {
                show: getCalendarEventMap,
                create: createCalendarEventMap,
                update: updateCalendarEventMap
            },
            featureTours: {
                get: getUserFeatureTour,
                update: updateUserFeatureTour,
                getContent: getFeatureTourContent
            },
            campaigns: {
                apply: postCampaignsApply
            },
            backbone: {
                read: backboneGet,
                create: backbonePost,
                update: backbonePut,
                delete: backboneDelete
            },
            availability: {
                get: getAvailability
            },
            uploadParameters: {
                create: postCreateUploadParameters
            },
            presentations: {
                create: postCreatePresentation
            },
            accountCompletion: {
                create: postCreateAccountCompletionStepForUser
            },
            mixpanel: {
                track: trackMixpanelEvent
            },
            developer: {
                reset: developerReset
            },

            // open for Jasmine
            defaultErrorHandler: defaultErrorHandler,
            sendRequest: sendRequest,
            apiConfig: getApiConfig
        };

        return _this;
    };
}).apply(Yesware);

// start loading
/////////////////////
if (typeof yeswareApiLoaded === "undefined") {
    yeswareApiLoaded = true;
    loadApi();
}

// to be defined
var handleFirefoxRequest;

function loadApi() {
    var BUILD_VERSION = "20150813133821";
    if (typeof yesLoad !== "undefined")
        yesLoad.saveBuildVersion(BUILD_VERSION);

    var yesApi;
    var PACKAGE_VERSION;

    if ($.browser.chrome) {
        PACKAGE_VERSION = chrome.app.getDetails().version;
        yesApi = Yesware.Api(BUILD_VERSION, PACKAGE_VERSION);
    } else {
        yesApi = Yesware.Api(BUILD_VERSION, ffSelf.version);
    }

    function onRequest(args) {
        var request = args.request;

        if ($.browser.mozilla) {
            request = args.request.action;
        }

        // chrome specific
        var sender = null, callback = worker;

        // firefox specific
        var worker = null;

        if ($.browser.chrome) {
            sender = args.sender;
            callback = args.callback;
        } else {
            // firefox
            worker = args.worker;
        }

        // users
        if (request.action === "users.show") {
            yesApi.users.show(request, callback, sender, worker);
        } else if (request.action === "users.create") {
            yesApi.users.create(request, callback, sender, worker);
        } else if (request.action === "users.update") {
            yesApi.users.update(request, callback, sender, worker);
        } else if (request.action === "users.lookup") {
            yesApi.users.lookup(request, callback, sender, worker);
        } else if (request.action === "users.signout") {
            yesApi.users.signout(request, callback, sender, worker);
        }

        // userPreferences
        else if (request.action === "userPreferences.show") {
            yesApi.userPreferences.show(request, callback, sender, worker);
        }
        else if (request.action === "userPreferences.update") {
            yesApi.userPreferences.update(request, callback, sender, worker);
        }
        else if (request.action === "userPreferences.import") {
            yesApi.userPreferences.import(request, callback, sender, worker);
        }

        // teams
        else if (request.action === "teams.show") {
            yesApi.teams.show(request, callback, sender, worker);
        }

        // template library
        else if (request.action === "templateLibrary.show") {
            yesApi.templateLibrary.show(request, callback, sender, worker);
        } else if (request.action === "templateLibrary.index") {
            yesApi.templateLibrary.index(request, callback, sender, worker);
        } else if (request.action === "templateLibrary.search") {
            yesApi.templateLibrary.search(request, callback, sender, worker);
        } else if (request.action === "templateLibrary.topTemplates") {
            yesApi.templateLibrary.topTemplates(request, callback, sender, worker);
        }

        // messages
        else if (request.action === "messages.index") {
            yesApi.messages.index(request, callback, sender, worker);
        } else if (request.action === "messages.create") {
            yesApi.messages.create(request, callback, sender, worker);
        } else if (request.action === "messages.update") {
            yesApi.messages.update(request, callback, sender, worker);
        }

        else if (request.action === "scheduledMessage.index") {
            yesApi.scheduledMessage.index(request, callback, sender, worker);
        } else if (request.action === "scheduledMessage.create") {
            yesApi.scheduledMessage.create(request, callback, sender, worker);
        } else if (request.action === "scheduledMessage.update") {
            yesApi.scheduledMessage.update(request, callback, sender, worker);
        } else if (request.action === "scheduledMessage.delete") {
            yesApi.scheduledMessage.delete(request, callback, sender, worker);
        } else if (request.action === "scheduledMessage.get") {
            yesApi.scheduledMessage.get(request, callback, sender, worker);
        }

        // reminders
        else if (request.action === "reminders.create") {
            yesApi.reminders.create(request, callback, sender, worker);
        } else if (request.action === "reminders.update") {
            yesApi.reminders.update(request, callback, sender, worker);
        } else if (request.action === "reminders.delete") {
            yesApi.reminders.delete(request, callback, sender, worker);
        }

        // usages
        else if (request.action === "usages.batch") {
            yesApi.usages.batch(request, callback, sender, worker);
        } else if (request.action === "usages.create") {
            yesApi.usages.create(request, callback, sender, worker);
        }

        // events
        else if (request.action === "events.grouped") {
            yesApi.events.grouped(request, callback, sender, worker);
        }
        else if (request.action === "events.thread") {
            yesApi.events.thread(request, callback, sender, worker);
        }

        // windows
        else if (request.action === "windows.create") {
            yesApi.windows.create(request.data, sender);
        }

        // tabs
        else if (request.action === "tabs.navigateTo") {
            yesApi.tabs.navigateTo(request.data, sender);
        } else if (request.action === "tabs.changeHashTo") {
            yesApi.tabs.changeHashTo(request.data, sender);
        } else if (request.action === "tabs.getUrl") {
            yesApi.tabs.getUrl(callback, sender);
        }

        // errors
        else if (request.action === "extensionErrorLog.create") {
            yesApi.extensionErrorLog.create(request, callback, sender, worker);
        }

        // oauth
        if (request.action === "oauth.start") {
            yesApi.oauth.start(request, sender, worker);
        } else if (request.action === "oauth.save") {
            yesApi.oauth.save(request, sender, worker);
        }

        // permissions
        if (request.action === "permissions.check") {
            yesApi.permissions.check(request, callback, sender, worker);
        }

        // gcal flow
        if (request.action === "gcalAuthFlow.start") {
            yesApi.gcalAuthFlow.start(request, sender, worker);
        } else if (request.action === "gcalAuthFlow.complete") {
            yesApi.gcalAuthFlow.complete(request, sender, worker);
        }

        // localStorage
        if (request.action === "localStorage.save") {
            yesApi.localStorage.save(request.data);
        } else if (request.action === "localStorage.load") {
            yesApi.localStorage.load(request, callback, worker);
        } else if (request.action === "localStorage.delete") {
            yesApi.localStorage.delete(request.data);
        }

        // users
        if (request.action === "background.users") {
            yesApi.background.getUsers(request, callback, worker);
        }

        // mapview
        if (request.action.indexOf("eventsMap.") !== -1) {
            if ($.browser.chrome) {
                yesApi.eventsMap.passMessage(sender.tab, request);
            }
        }

        // notifications
        if (request.action === "notifications.show") {
            yesApi.notifications.show(request, worker);
        }

        if (request.action === "richNotifications.show") {
            yesApi.richNotifications.show(request, callback, sender, worker);
        }

        // utilities
        if (request.action === "extensionVersion") {
            callback(chrome.app.getDetails().version);
        }

        if (request.action === "developer.reset") {
            yesApi.developer.reset();
        }

        // services
        if (request.action === "crmMetadata.show") {
            yesApi.crmMetadata.show(request, callback, sender, worker);
        }

        // message thread
        if (request.action === "crmMessageThread.show") {
            yesApi.crmMessageThread.show(request, callback, sender, worker);
        }

        // Salesforce
        if (request.action === "salesforce.get") {
            yesApi.salesforce.get(request, callback, sender, worker);
        } else if (request.action === "salesforce.post") {
            yesApi.salesforce.post(request, callback, sender, worker);
        } else if (request.action === "salesforce.getPhones") {
            yesApi.salesforce.getPhones(request, callback, sender, worker);
        }

        // calendar event map
        if (request.action === "calendarEventMap.show") {
            yesApi.calendarEventMap.show(request, callback, sender, worker);
        } else if (request.action === "calendarEventMap.create") {
            yesApi.calendarEventMap.create(request, callback, sender, worker);
        } else if (request.action === "calendarEventMap.update") {
            yesApi.calendarEventMap.update(request, callback, sender, worker);
        }

        // Feature Tours
        if (request.action === "featureTours.index") {
            yesApi.featureTours.get(request, callback, sender, worker);
        } else if (request.action === "featureTours.update") {
            yesApi.featureTours.update(request, callback, sender, worker);
        } else if (request.action === "featureTours.getContent") {
            yesApi.featureTours.getContent(request, callback, sender, worker);
        }

        // Drip Campaigns
        if (request.action === "drip_campaigns.apply") {
            yesApi.campaigns.apply(request, callback, sender, worker);
        }

        if (request.action === "backbone.read") {
            yesApi.backbone.read(request, callback, sender, worker);
        } else if (request.action === "backbone.create") {
            yesApi.backbone.create(request, callback, sender, worker);
        } else if (request.action === "backbone.update") {
            yesApi.backbone.update(request, callback, sender, worker);
        } else if (request.action === "backbone.delete") {
            yesApi.backbone.delete(request, callback, sender, worker);
        }

        if (request.action === "availability.get") {
            yesApi.availability.get(request, callback, sender, worker);
        }

        // Upload parameters for file attachments
        if (request.action == "uploadParameters.create") {
            yesApi.uploadParameters.create(request, callback, sender, worker);
        }

        if (request.action == "presentations.create") {
            yesApi.presentations.create(request, callback, sender, worker);
        }

        // account completion
        if (request.action == "accountCompletion.create") {
            yesApi.accountCompletion.create(request, callback, sender, worker);
        }

        if (request.action === "mixpanel.track") {
            yesApi.mixpanel.track(request, callback, sender, worker);
        }
    }

    // wire listeners for both browsers
    if ($.browser.chrome) {
        chrome.extension.onRequest.addListener(function (request, sender, callback) {
            onRequest({
                request: request,
                sender: sender,
                callback: callback
            });
        });
    } else {
        // firefox
        handleFirefoxRequest = function (request, worker) {
            onRequest({
                request: request,
                worker: worker
            });
        };
    }
}
var Yesware = Yesware || {};

// Shared code used by AjaxChrome and AjaxFirefox
//
// The functionality of this module is tested in YeswareAjaxSpec.js
(function() {
    this.AjaxCommon = function() {

        function shouldRetry(request, numTries) {
            return (request.retry && request.retry.times &&
                (numTries < request.retry.times));
        }

        function getDelay(request, numTries) {
            if (request.retry.delay) {
                if (Array.isArray(request.retry.delay)) {
                    return request.retry.delay[numTries];
                } else {
                    return request.retry.delay;
                }
            } else {
                return (5 * 1000); // 5 seconds
            }
        }

        var _this = {
            shouldRetry: shouldRetry,
            getDelay: getDelay
        };

        return _this;
    }
}).apply(Yesware);
var Yesware = Yesware || {};

// This module receives messages from content scripts and
// sends ajax requests on their behalf.
//
// The functionality of this module is tested in YeswareAjaxSpec.js
(function() {
    this.AjaxFirefox = function(Request, setTimeout) {
        var yesAjaxCommon = Yesware.AjaxCommon();

        // Listen is called by workers after they attach
        function listen(worker) {
            worker.port.on("ajaxRequest", function(message) {
                performRequest(message.ajaxRequest, message.requestId, worker.port, 0);
            });
        }

        function performRequest(request, requestId, port, attempt) {
            var options = requestOptions(request);

            options.onComplete = function(response) {
                handleResponse(request, response, requestId, port, attempt);
            }

            var requestObj = Request(options);

            switch(request.type) {
            case "GET":
                requestObj.get();
                break;
            case "POST":
                requestObj.post();
                break;
            case "PUT":
                requestObj.put();
                break;
            case "DELETE":
                requestObj.delete();
                break;
            }
        }

        function requestOptions(request) {
            var options = {};

            if (request.url) options.url = request.url;
            if (request.data) options.content = request.data;
            if (request.contentType) options.contentType = request.contentType;
            if (request.headers) options.headers = request.headers;

            return options;
        }

        function handleResponse(request, response, requestId, port, attempt) {
            var data = response.json || response.text;

            if (Math.floor(response.status / 100) === 2) {
                handleSuccess(data, response.statusText, requestId, port);
            } else {
                handleError(request, data, response.statusText, requestId, port, attempt);
            }
        }

        function handleSuccess(data, textStatus, requestId, port) {
            port.emit("ajaxResponse", {
                resolution: "success",
                data: data,
                textStatus: textStatus,
                requestId: requestId
            });
        }

        function handleError(request, data, textStatus, requestId, port, attempt) {
            if (yesAjaxCommon.shouldRetry(request, attempt)) {

                var delay = yesAjaxCommon.getDelay(request, attempt);

                setTimeout(function() {
                    performRequest(request, requestId, port, ++attempt);
                }, delay);

                port.emit("ajaxResponse", {
                    resolution: "retry",
                    data: data,
                    textStatus: textStatus,
                    requestId: requestId
                });
            } else {
                port.emit("ajaxResponse", {
                    resolution: "failure",
                    data: data,
                    textStatus: textStatus,
                    requestId: requestId
                });
            }
        }

        var _this = {
            listen: listen
        };

        return _this;
    }
}).apply(Yesware);
var pageMod = require("page-mod");
var Request = require("request").Request;
var setTimeout = require("sdk/timers").setTimeout;
var tabs = require("tabs");
var self = require("self");
var data = self.data;
var simpleStorage = require("simple-storage");

// see: http://stackoverflow.com/questions/12558983/nsisockettransportservice-using-firefox-addon-sdk
// for rewriting Google proxy images
const {Cc, Ci, Cu} = require("chrome");
Cu.import("resource://gre/modules/Services.jsm");

var observerService = Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService);
var HTTP_ON_MODIFY_REQUEST = "http-on-modify-request";
var HTTP_ON_EXAMINE_RESPONSE = "http-on-examine-response";

var yesConfig = Yesware.Config();
var yesAjaxFirefox = Yesware.AjaxFirefox(Request, setTimeout);
var yesHelpers = Yesware.Helpers();

function loadFrontend() {
    // fields
    /////////////////////
    var BASE = "https://yesware.dev";
    var VERSION = "devlocal";

    var BASE = "https://app.yesware.com";
    var VERSION = "production", DEVELOPMENT = false;
    var GCAL_ENABLED = true;

    // match all gmail frames
    var gmailMatches = [/(.+)mail.google.com\/(.+)/];

    // match all gcal tabs
    var gcalMatches = [/^https:\/\/www.google.com\/calendar\/(.+)/];

    // match all Salesforce tabs
    var salesforceMatches = [/^https:\/\/(.+).salesforce.com\/(.+)/];

    // workers
    /////////////////////
    var BUILD_VERSION = "20150813133821";
    var MARKETING_BASE = "http://www.yesware.com";
    var PACKAGE_VERSION;

    var workers = [];

    // gmail frontend
    pageMod.PageMod({
        include: gmailMatches,
        attachTo: ["existing", "top"],
        contentScriptFile: [self.data.url("jquery.min.js"),
            self.data.url("frontend.js"), self.data.url("mixpanel.js")],
        contentStyleFile: [self.data.url("frontend.css")],
        contentScriptWhen: "end",
        onAttach: onAttachFrontendJS
    });

    if (GCAL_ENABLED) {
        // gcal frontend
        pageMod.PageMod({
            include: gcalMatches,
            attachTo: ["existing", "top"],
            contentScriptFile: [self.data.url("jquery.min.js"), self.data.url("frontend_gcal.js")],
            contentStyleFile: [self.data.url("frontend.css")],
            contentScriptWhen: "end",
            onAttach: onAttachFrontendJS
        });
    }

    // Salesforce
    pageMod.PageMod({
        include: salesforceMatches,
        attachTo: ["top"],
        contentScriptFile: [self.data.url("jquery.min.js"), self.data.url("frontend_salesforce.js")],
        contentStyleFile: [self.data.url("frontend.css")],
        contentScriptWhen: "end",
        onAttach: onAttachFrontendJS
    });

    // workers
    function detachWorker(worker) {
        var index = workers.indexOf(worker);

        if (index !== -1) {
            workers.splice(index, 1);
        }
    }

    function onAttachFrontendJS(worker) {
        workers.push(worker);

        worker.on("message", function(request) {
            if (request.action.action === "worker.detach") {
                detachWorker(this);
            } else {
                handleFirefoxRequest(request, worker);
            }
        });

        worker.on("detach", function() {
            detachWorker(this);
        });

        yesAjaxFirefox.listen(worker);
    }

    // oauth
    /////////////////////
    var appMatches = [
        "http://app.yesware.com/*",
        "https://app.yesware.com/*",
        "http://yesware.dev/*",
        "https://yesware.dev/*",
        "http://yesware-cukes.test/*",
        "https://yesware-cukes.test/*"
    ];

    pageMod.PageMod({
        include: appMatches,
        contentScriptFile: self.data.url("oauth.js"),
        onAttach: function(worker) {
            workers.push(worker);

            worker.on("message", function(request) {
                handleFirefoxRequest(request, worker);
            });

            worker.on("detach", function() {
                detachWorker(this);
            });
        }
    });

    // gcal auth flow
    /////////////////////
    var authFlowSuccessMatches = [
        "http://app.yesware.com/auth/salesforce/auth_flow_success",
        "https://app.yesware.com/auth/salesforce/auth_flow_success",
        "https://localdev.yetihut.com/auth/salesforce/auth_flow_success",
        "https://localtest.yetihut.com/auth/salesforce/auth_flow_success"
    ];

    pageMod.PageMod({
        include: authFlowSuccessMatches,
        contentScriptFile: self.data.url("gcalflow.js"),
        onAttach: function(worker) {
            workers.push(worker);

            worker.on("message", function(request) {
                handleFirefoxRequest(request, worker);
            });

            worker.on("detach", function() {
                detachWorker(this);
            });
        }
    });

    // intro page
    /////////////////////
    function showIntro() {
        // have we already shown it?
        if (loadIntro() !== null)
            return;

        tabs.open("https://www.gmail.com/");

        saveIntro();
    }

    // on first install of extension
    showIntro();

    function introKey() {
        return "extension.yesware.introduced";
    }

    function loadIntro() {
        var tryIntro = simpleStorage.storage[introKey()];

        if (tryIntro === undefined) {
            return null;
        }

        return JSON.parse(tryIntro);
    }

    function saveIntro() {
        simpleStorage.storage[introKey()] = JSON.stringify(introJSON());
    }

    function introJSON() {
        return {
            version: PACKAGE_VERSION,
            shown: (new Date()).getTime()
        }
    }

    // rewrite Google proxy images
    /////////////////////
    function registerGoogleProxyRequestListeners() {
        // see: https://developer.mozilla.org/en-US/Add-ons/Overlay_Extensions/XUL_School/Intercepting_Page_Loads
        observerService.addObserver(
            function(aSubject, aTopic, aData) {
                aSubject.QueryInterface(Ci.nsIHttpChannel);

                var url = aSubject.URI.spec;

                if (yesConfig.regex.trackingPixel().test(url)) {
                    // redirect to the original tracking pixel
                    var originalSpacerUrl = url.split("#")[1];

                    if (originalSpacerUrl) {
                        var redirectUri = Services.io.newURI(originalSpacerUrl, null, null);
                        aSubject.redirectTo(redirectUri);
                    }
                }
            },
            HTTP_ON_MODIFY_REQUEST,
            false
        );
    }

    registerGoogleProxyRequestListeners();

    // Rewrite incoming Content-Security-Policy headers to allow loading of Yesware iframes
    // See: https://mixmax.com/blog/gmail-just-broke-every-chrome-extension
    /////////////////////
    function rewriteCSPHeaders() {

        observerService.addObserver(
            function(subject, topic, data) {
                if (topic !== HTTP_ON_EXAMINE_RESPONSE) {
                    return;
                }

                var httpChannel = subject.QueryInterface(Ci.nsIHttpChannel);
                var headerToModify;

                // Locate the CSP header, if any.
                // Don't modify it yet, though, since Firefox API docs say:
                // "Warning: Calling setResponseHeader() while visiting response
                // headers has undefined behavior. Don't do it!"
                httpChannel.visitResponseHeaders(function(header, value) {
                    if (/content-security-policy/i.test(header)) {
                        headerToModify = {
                            name: header,
                            value: value
                        };
                    }
                });

                // If we found a CSP, modify it.
                if (headerToModify) {
                    var newValue = yesHelpers.modifyCSPHeader(headerToModify.value);
                    httpChannel.setResponseHeader(headerToModify.name, newValue, false);
                }
            },
            HTTP_ON_EXAMINE_RESPONSE,
            false
        );
    }

    rewriteCSPHeaders();
}

// make modules available to main.js
exports.loadFrontend = loadFrontend;
